#include "parser/parser.h"
#include "ultra-cp/ultra-cp.h"
#include <linux/limits.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main(int argc, char **argv) {
    // Arguments parsing
    int source_count = 0;
    uint8_t opt = get_opt(argc, argv, "af", &source_count);

    // Destination parsing
    char *destination_path = argv[argc - 1];

    // Source parsing
    char **source_paths = malloc(source_count * sizeof(char *));
    for (int i = 0; i < source_count; i++) {
        source_paths[i] = malloc(PATH_MAX * sizeof(char));
        strcpy(source_paths[i], argv[optind - source_count + i]);

        // Trim ending slash if present
        if (source_paths[i][strlen(source_paths[i]) - 1] == '/')
            source_paths[i][strlen(source_paths[i]) - 1] = '\0';
    }

    // Copy content
    copy_files((const char **)source_paths, destination_path, opt, source_count);

    // Free sources
    for (int i = 0; i < source_count; i++)
        free(source_paths[i]);
    free(source_paths);

    return EXIT_SUCCESS;
}
